<?php
function join_JS_files($file_list, $strict) {
  $result = 
    "/* mechanically-generated file -- do not edit */\n" .
    (
      $strict? "'use strict';\n":
	#> in case the first file begins with "'use strict';"
	"'dummy string to turn off strict mode';\n"
    ) .
    "(function ($) {\n";

  foreach ($file_list as $file)
    $result .= file_get_contents($file) . "\n";

  $result .=
    "\n})(jQuery);\n";

  return $result;
}

function style_with_namespace($style, $namespace_prefix) {
  $style = preg_replace('@/\*.*?\*/@s', '', $style);

  return
    preg_replace_callback(
      '@(\A|\}).*?\{@s', 

      function ($matches) use ($namespace_prefix) {
	return preg_replace('/\.(?!ui-\S)/', ".$namespace_prefix",
	  $matches[0]);
      },

      $style
    );
}

function generate_CSS_namespace_file($CSS_class_namespace_prefix) {
  return
    "/* mechanically-generated file -- do not edit */\n" .
    "scinap.CSS_class_namespace_prefix = " .
    json_encode($CSS_class_namespace_prefix) . ";\n";
}
