function assert(condition, extra_info) {
  terminate_if_false(condition, 'assertion failed', extra_info);
}

function necessary(condition, extra_info) {
  terminate_if_false(condition, 'necessary condition does not obtain',
    extra_info);
}

function terminate_if_false(condition, intro_message, extra_info) {
  if(!condition) {
    var message =
      intro_message + (extra_info == null? '': ': ' + extra_info);

    try {
      /*
	this should help in IE 8 if Firebug Lite is loaded:
	it should mean we don't have to click on the little
	yellow icon to discover what went wrong
      */
      console.error(message); 
    } catch(dummy) {}

    throw new Error(message);
  }
}

function create_class() {
  var parts = {
    shared: {},
    constructor: function () {},
    method_implementation: {}
  };

  var destination = {
    function01: 'constructor',
    object01: 'method_implementation',

    function02: 'constructor',
    function12: 'constructor',
    object02: 'shared',
    object12: 'method_implementation',

    function13: 'constructor',
    object03: 'shared',
    object23: 'method_implementation'
  };

  var len = arguments.length;

  for(var i = 0; i < len; i++) {
    var key = type(arguments[i]) + i + len;

    if(destination.hasOwnProperty(key)) {
      parts[destination[key]] = arguments[i];
    } else
      throw new Error('invalid arguments');
  }

  for(var prop in parts.method_implementation)
    if(parts.method_implementation.hasOwnProperty(prop))
      parts.constructor.prototype[prop] =
	parts.method_implementation[prop];

  for(var prop in parts.shared)
    if(parts.shared.hasOwnProperty(prop))
      parts.constructor[prop] = parts.shared[prop];

  if(0) {
    console.dir(parts.constructor);
    console.dir(parts);
  }

  return parts.constructor;

  function type(x) {
    return x == null? String(x):
      ({}).toString.call(x).slice(8, -1).toLowerCase();
  }
}

function pixel_size(measurement) {
  var tmp =
    $('<div/>',
      {
	position: 'absolute',
	display: 'block',
	visibility: 'hidden',
	width: measurement
      }
    ).prependTo($('body'));
  var result = tmp.width();
  tmp.remove();
  return result;
}

/*
  based on code in zakas's book
*/
function load_style_string(css) {
    var style = document.createElement("style");
    style.type = "text/css";
    var text = document.createTextNode(css);
    try {
	style.appendChild(text);
    } catch (ex){
	style.styleSheet.cssText = css;
    }
    var head = document.getElementsByTagName("head")[0];
    head.appendChild(style);

    return style;
}
